package minilib;
;#=====================================
;# minilib.pl
;# 2000.10.31 K.Furuuchi
;#=====================================
;# to_crypt		2000.10.31
;# email_check	2000.11.08

#======================================================================
# to_crypt pX[ḧÍ
sub to_crypt {
	local($b_pwd) = @_;
	local($salt) = 'MI';

	if (not $b_pwd) { $a_pwd = ""; }
	else {
		$a_pwd = crypt $b_pwd, $salt;
	}

	return($a_pwd);
}
#======================================================================
# [AhX
sub email_check {
	local($email) = @_;
	local($esc, $Period, $space, $tab, $OpenBR, $CloseBR, $OpenParen, $CloseParen);
	local($NonASCII, $ctrl, $CRlist, $qtext, $dtext, $quoted_pair, $ctext, $Cnested);
	local($comment, $X, $atom_char, $atom, $quoted_str, $word, $domain_lit);
	local($sub_domain, $domain, $route, $local_part, $addr_spec, $route_addr);
	local($phrase_ctrl, $phrase_char, $phrase, $mailbox);

	if ($email eq '') { return(1); }
	$esc			= '\\\\';
	$Period			= '\.';
	$space			= '\040';
	$tab			= '\t';
	$OpenBR			= '\[';
	$CloseBR		= '\]';
	$OpenParen		= '\(';
	$CloseParen		= '\)';
	$NonASCII		= '\x80-\xff';
	$ctrl			= '\000-\037';
	$CRlist			= '\n\015';
	$qtext			= qq/[^$esc$NonASCII$CRlist\"]/;
	$dtext			= qq/[^$esc$NonASCII$CRlist$OpenBR$CloseBR]/;
	$quoted_pair	= qq<${esc}[^$NonASCII]>;
	$ctext			= qq<[^$esc$NonASCII$CRlist()]>;
	$Cnested		= qq<$OpenParen$ctext*(?:$quoted_pair$ctext*)*$CloseParen>;
	$comment		= qq<$OpenParen$ctext*(?:(?:$quoted_pair|$Cnested)$ctext*)*$CloseParen>;
	$X				= qq<[$space$tab]*(?:${comment}[$space$tab]*)*>;
	$atom_char		= qq/[^($space)<>\@,;:\".$esc$OpenBR$CloseBR$ctrl$NonASCII]/;
	$atom			= qq<$atom_char+(?!$atom_char)>;
	$quoted_str		= qq<\"$qtext*(?:$quoted_pair$qtext*)*\">;
	$word			= qq<(?:$atom|$quoted_str)>;$domain_ref  = $atom;
	$domain_lit		= qq<$OpenBR(?:$dtext|$quoted_pair)*$CloseBR>;
	$sub_domain		= qq<(?:$domain_ref|$domain_lit)$X>;
	$domain			= qq<$sub_domain(?:$Period$X$sub_domain)*>;
	$route			= qq<\@$X$domain(?:,$X\@$X$domain)*:$X>;
	$local_part		= qq<$word$X(?:$Period$X$word$X)*>;
	$addr_spec		= qq<$local_part\@$X$domain>;
	$route_addr		= qq[<$X(?:$route)?$addr_spec>];
	$phrase_ctrl	= '\000-\010\012-\037';
	$phrase_char	= qq/[^()<>\@,;:\".$esc$OpenBR$CloseBR$NonASCII$phrase_ctrl]/;
	$phrase			= qq<$word$phrase_char*(?:(?:$comment|$quoted_str)$phrase_char*)*>;
	$mailbox		= qq<$X(?:$addr_spec|$phrase$route_addr)>;

	if ($email =~ /^$mailbox$/o) { return(1); }
	else { return(-1); }
}
1;